unit Funcs;

{This is one LONG unit , it contains ALL the predefined functions in
 the QuickLisp library}

interface

uses Declars,Errors,Evaluate,Envs,MiscFunc,Storage,Uint;
var EndLoop : boolean;
{------------------------------------------------------------------------}
function Setq(var Token:cell):boolean;       {Setq}
function Quote(var Token:cell):boolean;      {'}
function Lambda(var Token:cell):boolean;     {Lambda}
function plus(var Token:cell):boolean;       {+}
function minus(var Token:cell):boolean;      {-}
function times(var Token:cell):boolean;      {*}
function division(var Token:cell):boolean;   {/}
function Let(var Token:cell):boolean;        {LET}
function Defun(var Token:cell):boolean;      {DEFUN}
function eq(var Token:cell):boolean;         {=}
function greater(var Token:cell):boolean;    {>}
function less(var Token:cell):boolean;       {<}
function eqgreater(var Token:cell):boolean;  {>=}
function eqless(var Token:cell):boolean;     {<=}
function neq(var Token:cell):boolean;        {<>}
function _if(var Token:cell):boolean;        {IF}
function Cons(var Token: Cell):boolean;      {CONS}
function Loop(var Token: Cell):boolean;      {LOOP}
function _Until(var Token:Cell):boolean;     {UNTIL}
function _While(var Token:Cell):boolean;     {WHILE}
function Car(var Token:Cell):boolean;        {CAR}
function Cdr(var Token:Cell): boolean;       {CDR}
function Atom(var Token:Cell):boolean;       {ATOM}
function _AND(var Token:cell):boolean;       {AND}
function _OR(var Token:cell):boolean;        {OR}
function _NOT(var Token:cell):boolean;       {NOT}
function Progn(var Token:cell):boolean;      {PROGN}
function Cond(var Token:Cell):boolean;       {COND}

function _Sin(var Token:Cell):boolean;       {SIN}
function _Cos(var Token:Cell):boolean;       {COS}
function _Tan(var Token:Cell):boolean;       {TAN}
function _ArcSin(var Token:Cell):boolean;    {ASIN}
function _ArcCos(var Token:Cell):boolean;    {ACOS}
function _ArcTan(var Token:Cell):boolean;    {ATAN}
function Modulo(var Token:Cell):boolean;     {%}
function Pow(var Token:Cell):boolean;        {POW}
function _Sqrt(var Token:Cell):boolean;      {SQRT}
function Rand(var Token:Cell):boolean;       {RAND}
function Rnd(var Token:Cell):boolean;        {RND}

function _StrLen(var Token:Cell):boolean;     {STRLEN}
function _Concat(var Token:Cell):boolean;     {CONCAT}
function Symbol(var Token:Cell):boolean;      {SYMBOL}
function _String(var Token:Cell):boolean;     {STRING}
function SubString(var Token:Cell):boolean;   {SUBSTRING}

function nth(var Token:Cell):boolean;         {NTH}
function List(var Token:Cell):boolean;        {LIST}

function Null(var Token:Cell):boolean;        {NULL}
function Member(var Token:Cell):boolean;      {MEMBER}
function _Eval(var Token:Cell):boolean;       {EVAL}
function Map(var Token:Cell):boolean;         {MAP}
function Apply(var Token:Cell):boolean;       {APPLY}
function Setf(var Token:Cell):boolean;        {SETF}

function IsVar(var Token:Cell):boolean;
function IsStr(var Token:Cell):boolean;
function IsNum(var Token:Cell):boolean;
function IsSym(var Token:Cell):boolean;
function IsBool(var Token:Cell):boolean;
function IsCons(var Token:Cell):boolean;

function Princ(var Token:Cell):boolean;
function Trace(var Token:Cell):boolean;
function Search(var Token:Cell):boolean;
implementation
{---------------------------------------------------------------------------}
function Setq(var Token:cell):boolean;
var Args  :         Cell;
    Name  :         LispVar;
begin
   Args:= Token.cdr^;

  if (((NumArgs(Args)/2) <> (int(NumArgs(Args)/2))) or {Check for equal no.}
       (NumArgs(Args)=0))  then                         {of syms and values}
   begin
      Error(7); Setq:=false; Exit;
   end;

   while (Args.Cell_Type <> tNull) do  {Loop for each group of args}
   begin
     Token := Args.Car^;
     if Token.Cell_Type <> tSym then      {Check literal}
     begin
               Error(8); Setq:=false; exit;
     end;

     Name:=Token.Name;     {Get name and..}
     LookUpSymbol(Token);  {Find first possible instance of it}

     Token:= Args.Cdr^.car^;

     if Eval(Token)=false then
      begin
          Setq:=false;  Exit;
      end;
     Environ.Add(Token,Name);    {Add symbol to environment}
     Args:=Args.cdr^.cdr^;       {Move to next arg input}
  end;
end;
{------------------------------------------------------------------------}
function plus(var Token:cell):boolean;
var Args :        Cell;
    Num  :        real;
    First:        boolean;
begin
     First:=true;
     Args:=Token.cdr^;
     while Args.Cell_Type<>tNull do     {For each value}
     begin
        Token:=Args.car^;   {Get value}

        if Eval(Token)= false then      {Eval it}
          begin
            plus:=false;   exit;
          end;

        if Token.cell_type <> tNum then  {If not number}
        begin
              Error(8);plus:=false;exit;
        end;

         if First=true then  {If this is the first value...}
         begin
            Num:=Token.Value_Num; {assign num to it}
            First:=false;
         end else
             Num  := Num+Token.Value_Num;   {Add}

        Args:=Args.cdr^;                    {move to next number}
     end;
  CreateNum(Token,' ',Num);
end;
{------------------------------------------------------------------------}
function minus(var Token:cell):boolean;
var Args:Cell;
    Num: Real;
    First:boolean;
begin
                {Like above only with minus instead}
   First:=true;
   Args:=Token.cdr^;

  while Args.Cell_Type<>tNull do     {For each value}
    begin
      Token:=Args.car^;

      if Eval(Token)= false then
        begin
           minus:=false;   exit;
        end;

     if Token.cell_type <> tNum then  {If not number}
        begin
              Error(8);minus:=false;exit;
        end;

    if First=true then
         begin
            Num:=Token.Value_Num;
            First:=false;
         end
         else Num:= Num-Token.Value_Num;

      Args:=Args.cdr^;
  end;
  CreateNum(Token,' ',Num);
end;
{------------------------------------------------------------------------}
function times(var Token:cell):boolean;
var Args:Cell;
    Num: Real;
    First:boolean;
                    {Like above only with times instead}
begin
     First:=true;
     Args:=Token.cdr^;

  while Args.Cell_Type<>tNull do     {For each value}
     begin
            Token:=Args.car^;

            if Eval(Token)= false then
              begin
                times:=false;   exit;
              end;

        if Token.cell_type <> tNum then  {If not number}
           begin
              Error(8);times:=false;exit;
           end;

        if First=true then
           begin
            Num:=Token.Value_Num;
            First:=false;
           end else
               Num:= Num*Token.Value_Num;

          Args:=Args.cdr^;
     end;
  CreateNum(Token,' ',Num);
end;
{------------------------------------------------------------------------}
function division(var Token:cell):boolean;
var Args:Cell;
    Num: Real;
    first:boolean;
                          {Same as above only division}
begin
     First:=true;
     Args:=Token.cdr^;

  while Args.Cell_Type<>tNull do     {For each value}
     begin
       Token:=Args.car^;

       if Eval(Token)= false then
         begin
           division:=false;   exit;
         end;


        if Token.cell_type <> tNum then  {If not number}
           begin
              Error(8);division:=false;exit;
           end;

        if First=true then
           begin
            Num:=Token.Value_Num;
            First:=false;
           end else
              Num:= Num/Token.Value_Num;

       Args:=Args.cdr^;
     end;

  CreateNum(Token,' ',Num);
end;
{------------------------------------------------------------------------}
function _AND(var Token:cell):boolean;
var Args: cell;
    Result :boolean;
    First :boolean;
begin
     First:=true;
     Args:=Token.cdr^;
                           {Same as above only AND}
     while Args.Cell_Type<>tNull do     {For each expression in arglist}
     begin
            Token:=Args.car^;

            if Eval(Token)= false then  {Evaluate it}
              begin
                _AND:=false;   exit;
              end;

            if First=true then
            begin
              Result:=Token.Value_Bool;
              First:=false;
            end else
             Result:= Result AND Token.Value_Bool;

            Args:=Args.cdr^;
     end;
    if Result= true then Token:=_TRUE else Token:=_FALSE;
end;
{------------------------------------------------------------------------}
function _OR(var Token:cell):boolean;
var Args: cell;
    Result :boolean;
    First : boolean;
begin
                      {Same as above only OR}
     First:=true;

     Args:=Token.cdr^;

     while Args.Cell_Type<>tNull do  {For each value...}
     begin
       Token:=Args.car^;

       if Eval(Token)= false then
        begin
          _OR:=false;   exit;
        end;

       if First=true then
       begin
          Result:=Token.Value_Bool;
          First:=false;
       end else

       Result:= Result OR Token.Value_Bool;
       Args:=Args.cdr^;
    end;
    if Result= true then Token:=_TRUE else Token:=_FALSE;
end;
{------------------------------------------------------------------------}
function _NOT(var Token:cell):boolean;
var Args: cell;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>1 then
     begin
          Error(5); _NOT:=false; Exit;
     end;

     Token:=Args.car^;

     if (Eval(Token)= false) then
     begin
        _NOT:=false; Exit;
     end;

     if Token.Cell_Type = tNull then Token:=_FALSE; {NIL CAN ACT AS BOOL,too}

     if (Token.Cell_Type<>tBool) then
     begin
         Error(14); _NOT:=false; Exit;
     end;

     Token.Value_Bool:=NOT(Token.Value_Bool); {Return inverse}
end;
{------------------------------------------------------------------------}

function Lambda(var Token:cell):boolean;   {Create a nameless function}
var Args:CellPtr;
begin
   Token.Cell_Type :=tFunc;
   args:=token.cdr;

   if NumArgs(Args^)<>2 then
    begin
         Error(5);Lambda:=false;exit;
    end;

   {In case of incorrect data types}
   if ((Args^.car^.Cell_type <> tCons) or (Args^.cdr^.car^.Cell_Type <> tCons))
   then begin
       Error(10);Lambda:=false; exit;
   end;

   Token.cdr := Args^.Car;         {Assign args of function}
   Token.Car := Args^.cdr;    {Assign body of function}
end;
{------------------------------------------------------------------------}
function Quote(var Token:cell):boolean;
begin
    if Token.cdr^.Cell_Type = tNull then     {This skips the evaluation}
    begin
         Error(11); Quote := false; exit;
    end;
    Token:=Token.cdr^;
end;
{------------------------------------------------------------------------}
{defun <Name> <Args> <Body>}
function Defun(var Token:cell):boolean;
var Name,Args,Body:CellPtr;
begin
     if NumArgs(Token.cdr^)< 3 then
     begin
          Error(5);Defun:=false;exit;
     end;
         {Get appropriate information}
     Name:=Token.Cdr^.Car;
     Args:=Token.Cdr^.Cdr^.Car;
     Body:=Token.Cdr^.Cdr^.Cdr;

     {In case of incorrect data types}
     if ((Args^.Cell_Type<>tCons) and (Args^.Cell_Type <> tNull)
         or  (Body^.Cell_Type<>tCons)) then
      begin
           Error(10);  Defun:= false; exit;
      end;
                               {Assign the:}
     Token.Name:=Name^.Name;      {Name}
     Token.cdr:=Args;           {Arguments}
     Token.Car:= Body;          {Body}
     Token.Cell_Type:= tFunc;    {Cell Type}
     Environ.Add(Token,Token.Name);  {Add to env}
end;
{------------------------------------------------------------------------}
function eq(var Token:cell):boolean;
var Args, Operand : cell;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then    {Only 2 args allowed}
     begin
          Error(5); Eq:=false; Exit;
     end;

     Token:=Args.car^;              {First operand}

     Operand:=Args.cdr^.car^;       {Second operand}

     if (Eval(Token)= false) or (Eval(Operand) = false) then
     begin
             Eq:=false; Exit;
     end;

    {Cells containing
                     0 of type tNum
                     false of type tBool
                     '' of type tString
                     '' of type tSym
        can be represented by nil}

      if Token.Cell_Type=tNull then Token.Cell_Type:=Operand.Cell_Type;
      if Operand.Cell_Type=tNull then Operand.Cell_Type:=Token.Cell_Type;

      if eqCell(Token,operand) then Token:=_TRUE else Token:=_FALSE;
end;
{------------------------------------------------------------------------}
function neq(var Token:cell):boolean;
var Args, Operand : cell;
begin                    {Same as above but returns true for a false input}
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); nEq:=false; Exit;
     end;

     Token:=Args.car^;
     Operand:=Args.cdr^.car^;

     if ((Eval(Token)= false) or (Eval(Token) = false)) then
     begin
          NEq:=false; Exit;
     end;

      if Token.Cell_Type=tNull then Token.Cell_Type:=Operand.Cell_Type;
      if Operand.Cell_Type=tNull then Operand.Cell_Type:=Token.Cell_Type;

            if eqCell(Token,operand) then Token:=_FALSE else Token:=_TRUE;
end;
{------------------------------------------------------------------------}
function greater(var Token:cell):boolean;
var Args,  Operand : cell;
begin                           {Same as above but return true if token
                                 is greater than operand}
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); Greater:=false; Exit;
     end;

     Token:=Args.car^;
     Operand:=Args.cdr^.car^;

     if ((Eval(Token)= false) or (Eval(Operand) = false)) then
     begin
          Greater:=false; Exit;
     end;

     if (Token.Cell_Type<> Operand.Cell_Type) then
     begin
         Error(12); Greater:=false; Exit;
     end;

     case Token.Cell_Type of
          tNum : if Token.Value_Num > Operand.Value_Num then Token:=_TRUE else Token:= _FALSE;
          tString: if Token.Value_Str > Operand.Value_Str then Token:=_TRUE else Token:= _FALSE;
          tBool: if Token.Value_Bool > Operand.Value_Bool then Token:=_TRUE else Token:= _FALSE;
          else begin
                 Error(13); Greater:=false;exit;
                end;

     end;
end;
{------------------------------------------------------------------------}
function less(var Token:cell):boolean;
var Args, Operand : cell;
begin
                         {Same as above but return true if token
                                 is less than operand}
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); Less:=false; Exit;
     end;

     Token:=Args.car^;
     Operand:=Args.cdr^.car^;

     if ((Eval(Token)= false) or (Eval(Operand) = false)) then
     begin
           Less:=false; Exit;
     end;

     if Token.Cell_Type<> Operand.Cell_Type then
     begin
         Error(12); Less:=false; Exit;
     end;

     case Token.Cell_Type of
          tNum : if Token.Value_Num < Operand.Value_Num then Token:=_TRUE else Token:= _FALSE;
          tString: if Token.Value_Str < Operand.Value_Str then Token:=_TRUE else Token:= _FALSE;
          tBool: if Token.Value_Bool < Operand.Value_Bool then Token:=_TRUE else Token:= _FALSE;
          else begin
              Error(13); Less:=false;exit;
          end;
     end;
end;
{------------------------------------------------------------------------}
function eqgreater(var Token:cell):boolean;
var Args, Operand : cell;
begin
 {Same as above but return true if token is greater or equal to operand}
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); EqGreater:=false; Exit;
     end;

     Token:=Args.car^;
     Operand:=Args.cdr^.car^;

    if ((Eval(Token)= false) or (Eval(Operand) = false)) then
     begin
           EqGreater:=false; Exit;
     end;

     if Token.Cell_Type<> Operand.Cell_Type then
     begin
         Error(12); EqGreater:=false; Exit;
     end;

     case Token.Cell_Type of
          tNum : if Token.Value_Num >= Operand.Value_Num then Token:=_TRUE else Token:= _FALSE;
          tString: if Token.Value_Str >= Operand.Value_Str then Token:=_TRUE else Token:= _FALSE;
          tBool: if Token.Value_Bool >= Operand.Value_Bool then Token:=_TRUE else Token:= _FALSE;
          else begin
              Error(13); EqGreater:=false;exit;
          end;
     end;
end;
{------------------------------------------------------------------------}
function eqless(var Token:cell):boolean;
var Args, Operand : cell;
begin
                         {Same as above but return true if token
                                 is less or equal to operand}
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); EqLess:=false; Exit;
     end;

     Token:=Args.car^;
     Operand:=Args.cdr^.car^;

     if ((Eval(Token)= false) or (Eval(Operand) = false)) then
     begin
           EqLess:=false; Exit;
     end;

     if Token.Cell_Type<> Operand.Cell_Type then
     begin
         Error(12); EqLess:=false; Exit;
     end;

     case Token.Cell_Type of
          tNum : if Token.Value_Num <= Operand.Value_Num then Token:=_TRUE else Token:= _FALSE;
          tString: if Token.Value_Str <= Operand.Value_Str then Token:=_TRUE else Token:= _FALSE;
          tBool: if Token.Value_Bool <= Operand.Value_Bool then Token:=_TRUE else Token:= _FALSE;
          else begin
              Error(13); EqLess:=false;exit;
          end;
     end;
end;
{------------------------------------------------------------------------}
function _if(var Token:cell):boolean;
var Value:cell;
begin
    Value:=Token.cdr^.Car^;

    if Eval(Value) = false then {Evaluate condition}
    begin
        _if:=false;exit;
    end;

    if Value.Cell_Type=tNull then Value:=_FALSE;

    if Value.Cell_Type<> tBool then
    begin
          Error(14);_if:=false;exit;
    end;

    if Value.Value_Bool = true then   {if condition is true then}
    begin
     Value:=Token.cdr^.cdr^.car^;
       if Eval(Value) = false then  {Evaluate true expression}
       begin
            _if:=false; Exit;
       end;
    end
    else begin
     if Token.cdr^.cdr^.cdr^.Cell_Type<> tNull then  {If the else closure exists}
     begin
       Value:= Token.cdr^.cdr^.cdr^.car^;
       if Eval(Value) = false then     {if condition is not true}
       begin
            _if:=false; Exit;
       end;
     end;
  end;
    Token:=Value;
end;
{------------------------------------------------------------------------}
function Cons(var Token: Cell):boolean;
var List : cell;
begin
     if NumArgs(Token.cdr^) <> 2  then
     begin
          Error(5); Cons := false; Exit;
     end;

      {Get approriate information}
     List := Token.cdr^.car^;
     Token := Token.cdr^.cdr^.car^;

     if ((Eval(List)= false) or (Eval(Token)= false)) then
     begin
         Cons:= false; Exit;
     end;

     CreateCons(Token,List,Token);
end;
{------------------------------------------------------------------------}
{ (LET ( (Local vars)... )
       ( <body>))}
function Let(var Token:cell):boolean;
var Value,Args,ArgList :Cell;
    Name       : LispVar;
    i          : integer;
begin
   inc(Level);          {Move an  environment higher}
   CurLevel:=Level;

  if NumArgs(Token.cdr^)<>2 then
   begin
            Error(5); Let:=false; exit;
   end;
   Args:= Token.cdr^.car^;
   ArgList:=Args;

      {Declaration of local variables}
  for i := 1 to NumArgs(Args) do     {for each var}
  begin                              {get value}
    Value := Args.car^.car^;

    if (Value.Cell_Type <> tSym) then      {Check if symbol}
     begin
          Error(8); Let:=false; exit;
     end;

    Name:=Value.Name;                       {get name}

    if Args.car^.Cdr^.Cell_Type= tNULL then  {assign nil if there is no value}
    begin
         Value:=_NULL;
    end
    else begin
           Value := Args.car^.cdr^.car^; {otherwise , obtain value}

           if Eval(Value)=false then
           begin
               Let:=false;  Exit;
           end;
         end;
   CurLevel:=Level;
   Environ.Add(Value,Name);        {Add the value}
   Args:=Args.cdr^;       {Move to next arg input}
  end;

   {Local Program execution part}
   Args:= Token.cdr^.cdr^.car^;

   for i := 1 to NumArgs(Args) do   {for each line}
   begin
        Value:= Args.car^;              {obtain line}
        if Eval(Value) = false then    {evaluate line}
        begin
             Let:=false; exit;
        end;
        Args:=args.cdr^;             {move to next line}
   end;
   Token:=Value;
   Environ.decLevel;
end;
{------------------------------------------------------------------------}
{ Loop <Body> Until <Cond> | While <Cond>}
function Loop(var Token: Cell):boolean;
var Args : Cell;
    Value: Cell;
begin
    EndLoop := False;
    Args := Token.cdr^;
    if Args.Cell_Type = tNull then
    begin
         Error(15);Loop:=false; Exit;
    end;

    while  EndLoop =false do     {While until/while do not set endloop true}
     begin
        Token := Args;
        while Token.Cell_Type <> tNull do
         begin
             Value:=Token.Car^;     {Get value}
             if Eval(Value)=false then  {Evaluate it}
             begin
                  Loop:=false; exit;
             end;
             Token:=Token.Cdr^;
         end;
     end;
    Token:=Value;
end;
{------------------------------------------------------------------------}
function _Until(var Token:Cell):boolean;
var Args: Cell;
begin
     Args:= Token.cdr^;

     if Token.Cdr^.Cell_Type =tNull then
     begin
          Error(5); _Until := false; Exit;
     end;

     Token := Token.cdr^.car^;
     if Eval(Token) = false then   {Get condition}
      begin
           _Until :=false; Exit;
      end;

     if Token.Value_Bool= true then EndLoop:=true;
     if Args.cdr^.Cell_Type<>tNull then Token:=Args.cdr^.car^;
end;
{------------------------------------------------------------------------}
function _While(var Token:Cell):boolean;
var Args: Cell;
begin
     {Same as above only endloop is set to true if Token=False}
     Args:=Token.Cdr^;
     if Token.Cdr^.Cell_Type =tNull then
      begin
          Error(6); _While := false; Exit;
      end;

     Token := Token.cdr^.car^;
     if Eval(Token) = false then
      begin
          _While :=false; Exit;
      end;
     if Token.Cell_Type=tNull then Token:=_FALSE;
     if Token.Value_Bool= false then EndLoop:=true;
     if Args.cdr^.Cell_Type<>tNull then Token:=Args.cdr^.car^;
end;
{------------------------------------------------------------------------}
function Car(var Token:Cell):boolean;
begin
     Token := Token.cdr^.car^;

     if Eval(Token) = false then
     begin
          Car:=false;Exit;
     end;

     if Token.car <> nil then Token:=Token.car^ {If there is no head return}
     else Token:=_NULL;                          {NIL}
end;
{------------------------------------------------------------------------}
function Cdr(var Token:Cell): boolean;
begin
     Token := Token.cdr^.car^;

     if Eval(Token) = false then
      begin
          Cdr:=false;Exit;
      end;

     if Token.cdr <> nil then Token:=Token.cdr^ {If there is no rest}
     else Token:=_NULL;                         {return NIL}
end;
{------------------------------------------------------------------------}
function Atom(var Token:Cell):boolean;
begin
     if NumArgs(Token.cdr^)<>1 then
     begin
          Error(5); Atom:=false; Exit;
     end;

     Token:= Token.cdr^.car^;
     if Eval(Token)= false then
     begin
          Atom:=false; Exit;
     end;
     if isAtom(Token) = true then Token:=_TRUE
     else Token:=_FALSE;
end;
{------------------------------------------------------------------------}
function Progn(var Token:cell):boolean;
var Args:Cell;
begin
  {Function Body execution}
    Args:=Token.cdr^;
    while Args.Cell_Type <> tNull do
    begin
      Token:=Args.car^;       {Get the first line}
      if (Eval(Token) = false) then      {Evaluate the code}
       begin
          Progn:=false; exit;
       end;
      Args:=Args.cdr^;     {Move to next line}
   end;
end;
{------------------------------------------------------------------------}
function Cond(var Token:Cell):boolean;
var Args, Clause : Cell;
begin
     Args:= Token.cdr^;
     while Args.Cell_Type <> tNull do
     begin
         Clause :=Args.car^;
         if isAtom(Clause) then         {Expected list}
          begin
            Error(10); Cond := false; Exit;
          end;

         Token := Clause.car^;   {Get condition from clause}

         if Eval(Token) = false then   {Evaluate condition}
          begin
              Cond:=false; Exit;
          end;

         if Token.Cell_Type=tNull then Token:=_FALSE;
         if Token.Cell_Type <> tBool then  {Condition MUST return bool}
          begin
              Error(14); Cond:=false; Exit;
          end;

         if Token.Value_Bool = true then {If true then...}
          begin
              if Clause.cdr^.cell_type = tNull then exit;
                                         {Execute expression}
              Token:=Clause.cdr^.car^;
              if Eval(Token) = false then
               begin
                   Cond:=false; Exit;
               end;
              exit;
         end;
       Args:=Args.cdr^; {Move to next clause}
     end;
end;
{------------------------------------------------------------------------}
function _Sin(var Token:Cell):boolean;
begin
    Token := Token.cdr^.car^;
    if (Eval(Token) = false) then
    begin
         _Sin:=False; Exit;
    end;
    if Token.Cell_Type<>tNum then
    begin
         Error(9);_Sin:=False;exit;
    end;
    CreateNum(Token,' ',Sin(Token.Value_Num) ); {return value}
end;
{------------------------------------------------------------------------}
function _Cos(var Token:Cell):boolean;
begin
    Token := Token.cdr^.car^;
    if Eval(Token) = false then
    begin
         _Cos:=False; Exit;
    end;
    IF Token.Cell_Type<>tNum then
    begin
         Error(9);_Cos:=False; Exit;
    end;
     {return value}
    CreateNum(Token,' ',Cos(Token.Value_Num) );
end;
{------------------------------------------------------------------------}
function _Tan(var Token:Cell):boolean;
begin
    Token := Token.cdr^.car^;
    if Eval(Token) = false then
    begin
         _Tan:=False;Exit;
    end;

    if Token.Cell_Type<>tNum then
    begin
         Error(9);_Tan:=False;Exit;
    end;
     {return value}
    CreateNum(Token,' ',sin(Token.Value_Num)/cos(Token.Value_Num) );
end;
{------------------------------------------------------------------------}
function _ArcSin(var Token:Cell):boolean;
var  Num : real;
begin
    Token := Token.cdr^.car^;
    if Eval(Token) = false then
    begin
         _ArcSin:=False; Exit;
    end;

    if Token.Cell_Type<>tNum then
    begin
         Error(9);_ArcSin:=false;exit;
    end;

    Num:= Token.Value_Num;
     {return value}
    CreateNum(Token,' ',ArcTan (Num/sqrt (1-sqr (Num))) );
end;
{------------------------------------------------------------------------}
function _ArcCos(var Token:Cell):boolean;
var Num : real;
begin
    Token := Token.cdr^.car^;
    if Eval(Token) = false then
    begin
         _ArcCos:=False; Exit;
    end;

    if Token.Cell_Type<>tNum then
    begin
         Error(9);_ArcCos:=false;exit;
    end;

    Num:= Token.Value_Num;
     {return value}
    CreateNum(Token,' ', ArcTan (sqrt (1-sqr (Num)) /Num));
end;
{------------------------------------------------------------------------}
function _ArcTan(var Token:Cell):boolean;
begin
    Token := Token.cdr^.car^;
    if Eval(Token) = false then
    begin
         _ArcTan:=False;Exit;
    end;

    if Token.Cell_Type<>tNum then
    begin
         Error(9);_ArcTan:=false;exit;
    end;
     {return value}
    CreateNum(Token,' ',ArcTan(Token.Value_Num) );
end;
{------------------------------------------------------------------------}
function Modulo(var Token:Cell):boolean;
var Args, Operand : cell;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); Modulo:=false; Exit;
     end;
     Token:=Args.car^;  {Get first value}
     Operand:=Args.cdr^.car^; {Get operand}

     {Evaluate them}
     if ((Eval(Token)= false) or (Eval(Operand) = false)) then
     begin
            Modulo:=false; Exit;
     end;

     {Must be of type tNum}
     if ((Token.Cell_Type<>tNum) and (Operand.Cell_Type<>tNum)) then
     begin
         Error(9); Modulo:=false; Exit;
     end;
      {return value}
    CreateNum(Token,'',Round(Token.Value_Num) mod Round(Operand.Value_Num));
end;
{------------------------------------------------------------------------}
function Pow(var Token:Cell):boolean;
var Args, Operand :Cell;
begin
     {Same as above, only Power}
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); Pow:=false; Exit;
     end;
     Token:=Args.car^;
     Operand:=Args.cdr^.car^;

     if ((Eval(Token)= false) or (Eval(Operand) = false)) then
     begin
             Pow:=false; Exit;
     end;

     if ((Token.Cell_Type<>tNum) and (Operand.Cell_Type<>tNum)) then
     begin
         Error(9); Pow:=false; Exit;
     end;

    CreateNum(Token,'',Power(round(Token.Value_Num), Round(Operand.Value_Num)));
end;
{------------------------------------------------------------------------}
function _Sqrt(var Token:Cell):boolean;
var Args: cell;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>1 then
     begin
          Error(5); _Sqrt:=false; Exit;
     end;
     Token:=Args.car^;

     if (Eval(Token)= false)then
     begin
         _Sqrt:=false; Exit;
     end;
     {Must be number}
     if (Token.Cell_Type<>tNum)then
     begin
         Error(9); _Sqrt:=false; Exit;
     end;
     {Return Value}
    CreateNum(Token,'',Sqrt(Token.Value_Num));
end;
{------------------------------------------------------------------------}
function Rand(var Token:Cell):boolean;
var Args: cell;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>1 then
     begin
          Error(2); Rand:=false; Exit;
     end;
     Token:=Args.car^;

     if (Eval(Token)= false)then
     begin
              Rand:=false; Exit;
     end;

     if (Token.Cell_Type<>tNum)then
     begin
         Error(9); Rand:=false; Exit;
     end;
     {Return Value}
    CreateNum(Token,'',Random(round(Token.Value_Num)));
end;
{------------------------------------------------------------------------}
function Rnd(var Token:Cell):boolean;
var Args: cell;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>1 then
     begin
          Error(5); Rnd:=false; Exit;
     end;
     Token:=Args.car^;

     if (Eval(Token)= false)then
     begin
           Rnd:=false; Exit;
     end;

     if (Token.Cell_Type<>tNum)then
     begin
         Error(9); Rnd:=false; Exit;
     end;
     {Return Rounded value}
    CreateNum(Token,'',(round(Token.Value_Num)));
end;
{------------------------------------------------------------------------}
function _StrLen(var Token:Cell):boolean;
var Args: cell;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>1 then
     begin
          Error(5); _StrLen:=false; Exit;
     end;
     Token:=Args.car^;

     if (Eval(Token)= false)then
     begin
           _StrLen:=false; Exit;
     end;
     {Must be of type string}
     if (Token.Cell_Type<>tString)then
     begin
         Error(16); _StrLen:=false; Exit;
     end;
     {Return number}
    CreateNum(Token,'',(length(Token.value_str)));
end;

{------------------------------------------------------------------------}
function _Concat(var Token:Cell):boolean;
var Args:Cell;
    ResultStr : LispString;
begin
   Args:=Token.cdr^;
   ResultStr :='';
     while  (Args.Cell_Type <> tNull) do   {For each value}
     begin
          Token:=Args.car^;

          if Eval(Token)= false then       {Get physical value}
          begin
           _Concat:=false;  Exit;
          end;

          if Token.Cell_Type<>tString then
          begin
           Error(16);_Concat:=false;exit;
          end;

          ResultStr:=ResultStr + Token.Value_Str; {Append to string }
          Args:=Args.cdr^;     {Move to next value}
     end;
     {Return value}
  CreateStr(Token,'',ResultStr);
end;
{------------------------------------------------------------------------}
function Symbol(var Token:Cell):boolean;
var Args:  cell;
    i:integer;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>1 then
     begin
          Error(5); Symbol:=false; Exit;
     end;
     Token:=Args.car^;

     if (Eval(Token)= false)then
     begin
             Symbol:=false; Exit;
     end;

     if (Token.Cell_Type<>tString)then
     begin
         Error(16); Symbol:=false; Exit;
     end;
     {Convert to upper case}
     for i := 1 to length(Token.Value_Str) do
        Token.Value_Str[i]:=upCase(Token.Value_Str[i]);

    {Return symbol of name string}
    CreateSym(Token,Token.Value_Str,tSym);
end;
{------------------------------------------------------------------------}
function _String(var Token:Cell):boolean;
var Args: cell;
    Result: LispString;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>1 then
     begin
          Error(5); _String:=false; Exit;
     end;
     Token:=Args.car^;

     if (Eval(Token)= false)then
     begin
         _String:=false; Exit;
     end;

  case Token.Cell_Type of
    tSym : Result:=Token.Name;
    tNum : Str(trunc(Token.value_num),Result);
    tString: Result:=Token.value_str;
    tFunc: Result:=Token.Name;
    tBool: if Token.Value_Bool=true then Result:='T' else Result:='NIL';
    tNull: Result:='NIL';
 end;

    {Create string }
    CreateStr(Token,'',Result);
end;
{------------------------------------------------------------------------}
function SubString(var Token:Cell):boolean;
var Args : cell;
    i,st,li : integer;
    Str ,Substr: LispString;
begin
     Args:= Token.cdr^;
     if ((NumArgs(Args)<>3) and (NumArgs(Args)<>2)) then
     begin
          Error(5); SubString:=false; Exit;
     end;
     {Extraction of string}
     Token:=Args.car^;
      if (Eval(Token)= false) then
       begin
              SubString:=false; Exit;
       end;

       if Token.Cell_Type<>tString then
       begin
                Error(16); Substring:=false; Exit;
       end;
       Str := Token.Value_Str;

     {Extraction of start}
      Token:=Args.cdr^.car^;

     if (Eval(Token)= false) then
       begin
              SubString:=false; Exit;
       end;

       if Token.Cell_Type<>tNum then
       begin
                Error(9); Substring:=false; Exit;
       end;
       st := round(Token.Value_Num);

     {Extraction of Limit}
     IF Args.cdr^.cdr^.Cell_Type <> tNull then
     begin
      Token:=Args.cdr^.car^;

      if (Eval(Token)= false) then
       begin
              SubString:=false; Exit;
       end;

       if Token.Cell_Type<>tNum then
       begin
                Error(9); Substring:=false; Exit;
       end;
    li := round(Token.Value_Num);
     end else Li:=length(Str);


     {Boundaries must be in range!!!}
     if ((st > Length(Str)) or
         (li > Length(Str))) then
     begin
         Error(17); SubString :=false; Exit;
     end;
     Substr:='';

     {Create String}
     for i:=st to Li do
         Substr:=Substr + Str[i];

    {Return String}
     CreateStr(Token,'',Substr);
end;

{------------------------------------------------------------------------}
function nth(var Token:Cell):boolean;
var Args, n, List : cell;
    i : integer;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); nth:=false; Exit;
     end;
   {Extract list and n}
     n:=Args.car^;
     List:=Args.cdr^.car^;

     if ((Eval(n)= false) or (Eval(List) = false)) then
     begin
              Nth:=false; Exit;
     end;

     if n.Cell_Type<>tNum then
     begin
         Error(9); nth:=false; Exit;
     end;

     if List.Cell_Type<>tCons then
     begin
          Error(10); nth:=false;exit;
     end;

     {n must be in range}
     if n.Value_Num > NumArgs(List) then
     begin
         Token:=_NULL;exit;
     end;

     {Get nth value}
     for i:= 0 to round(n.Value_Num)-1  do
     begin
          List:=List.cdr^;
     end;
     {Return it}
     Token:=List.car^;
end;

{------------------------------------------------------------------------}
function List(var Token:Cell):boolean;
var Args:Cell;
    Head : cell;
    Ptr : CellPtr;
begin
     Args:=Token.cdr^;

     Token:=_NULL;
     Ptr := @Token; {Set pointer to the token}
     while Args.Cell_Type <> tNull do
     begin
      Head := Args.car^; {Get each value}

       if Eval(Head)= false  then
          begin
            List:=false; exit;
          end;
       CreateCons(Ptr^,Head,_NULL); {Add head to token}
       Ptr:=Ptr^.cdr;  {Move token by one}
       Args:=Args.cdr^;   {Move List by one}
       end;
end;
{------------------------------------------------------------------------}
function Null(var Token:Cell):boolean;
var Args: cell;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)>1 then
      begin
          Error(5); NULL:=false; Exit;
      end;

     Token:=Args.car^;

     if (Eval(Token)= false) then
      begin
              NULL:=false; Exit;
      end;

     if (Token.Cell_Type=tNull) then Token:=_TRUE
     else Token:=_FALSE;
end;
{------------------------------------------------------------------------}
function Member(var Token:Cell):boolean;
var Args, Sym, List : cell;
    i : integer;
    found : boolean;
begin
     Args:= Token.cdr^;
     if NumArgs(Args)<>2 then
     begin
          Error(5); Member:=false; Exit;
     end;

{Get symbol and list}
     Sym:=Args.car^;
     List:=Args.cdr^.car^;

     if ((Eval(Sym)= false) or (Eval(List) = false)) then
      begin
        Member:=false; Exit;
      end;

      if List.Cell_Type<>tCons then
      begin
           Error(10);Member:=false;exit;
      end;

     found := false;

{Search for instance in list}
     for i:= 1 to NumArgs(List)  do
      begin
          if EqCell(Sym,List.car^) then found:= true; {if found..}
          List:=List.cdr^; {if not found move to next node}
      end;
     if found = true then Token := _TRUE else Token:= _FALSE;
end;
{------------------------------------------------------------------------}
function _Eval(var Token:Cell):boolean;
var List : cell;
begin
     if NumArgs(Token.cdr^) <> 1 then
        begin
             Error(5);_Eval:=false;exit;
        end;
{Obtain cons}
     List := Token.cdr^.car^;
     if Eval(List) = false then
     begin
          _Eval:=false;Exit;
     end;

{Evaluate cons}
     Token:=List;
     if Eval(Token) = false then
     begin
          _Eval:= false; Exit;
     end;
end;
{------------------------------------------------------------------------}
function Map(var Token:Cell):boolean;
var Args, Current,List,Value, Func : Cell;
    Ptr                            : CellPtr;
    i,Items                        : integer;
begin

     Args:= Token.cdr^;
     Ptr := @Token; {Set a pointer to the main token}
     if NumArgs(Args)<> 2 then
     begin
          Error(5); Map := false; Exit;
     end;
     Func := Args.car^;        {Get function}

     If Eval(Func) = false then     {Obtain physical value}
     begin
          Map := false; exit;
     end;

     List:= Args.cdr^.car^;   {Get list}

     if Eval(List) = false then    {Obtain physical value}
     begin
          Map := false; exit;
     end;

     Items := NumArgs(List);
     for i := 1 to Items do {For each item in list..}
       begin
        Value:=_NULL;             {Create a new cons with function + arg}
        Current := List.car^;
        CreateCons(Value,Current, _NULL);
        CreateCons(Value,Func,Value);

        if Eval(Value) = false then  {Eval new cons}
        begin
             Map := false; exit;
        end;

        CreateCons(Ptr^,Value,_NULL);   {Add result to output list}
        Ptr:=Ptr^.cdr;
        List:=List.cdr^;
     end;
end;
{------------------------------------------------------------------------}
{
        Eval the first symbol
        Eval the args
        Create a new token with car as the first symbol and the args
               as token.cdr;
        eval new token it;
}
function Apply(var Token:Cell):boolean;
var F:cell;
    Args:cell;
begin
     if NumArgs(Token.cdr^)<> 2 then
     begin
          Error(5);Apply:=false;exit;
     end;

     F:=Token.cdr^.car^;           {Get Function}
     if Eval(F)= false then
     begin
          Apply:=false;exit;
     end;

     Args:=Token.cdr^.cdr^.car^;   {Get arguments}
     if Eval(Args)= false then
     begin
          Apply:=false;exit;
     end;

     CreateCons(Token,F,Args);     {Create a new cons contain func+ args}

     if Eval(Token)=false then  {Eval new cons}
     begin
          Apply:=false;exit;
     end;
end;
{------------------------------------------------------------------------}
function Setf(var Token:Cell):boolean;
var Args : Cell;
    Value: Cell;
    Name:LispVar;
begin
   Args:= Token.cdr^;

  if (((NumArgs(Args)/2) <> (int(NumArgs(Args)/2))) and (NumArgs(Args)=0))  then
   begin
      Error(7); Setf:=false; Exit;
   end;

   while (Args.Cell_Type <> tNull) do  {Loop for each group of args}
   begin
     Value := Args.Car^;
     if isAtom(Value) = true then      {Check literal}
     begin
          Error(18); Setf:=false; exit;
     end;

     Token:= Args.Cdr^.car^;

     if Eval(Token)=false then  {In case of being a function}
      begin
            Setf:=false;  Exit;
      end;

    if Value.Cell_Type = tSym then  {Must be a symbol}
     begin
          Name:=Value.Name;
          LookupSymbol(Value);  {Find first possible instance of it}
          Environ.Add(Token,Name);
     end
     else begin                    {Must be a pointer}
     if Eval(Value) = false then
     begin
          Setf:=false;Exit;
     end;
       Value.rubbish:=true;
       Token.Address:=Value.Address;
       Value.Address^:=Token;
     end;
     Args:=Args.cdr^.cdr^;       {Move to next arg input}
  end;
end;
{------------------------------------------------------------------------}
function IsVar(var Token:Cell):boolean;
var Value:Cell;
begin
   if NumArgs(Token.cdr^)<> 1 then begin
      Error(5); IsVar:=false; exit;
   end;

     Value:=Token.cdr^.car^; {Search for symbol in environments}
     if LookUpSymbol(Value)=true then Token:=_TRUE else Token:=_FALSE;
end;
{------------------------------------------------------------------------}
function IsNum(var Token:Cell):boolean;
var Value:Cell;
begin
   if NumArgs(Token.cdr^) <>1 then begin
      Error(5);IsNum:=false;exit;
   end;

     Value:=Token.cdr^.car^;
    if Eval(Value)= false then
    begin
         IsNum:=false; exit;
    end;
    {If number return true}
    if Value.cell_type=tNum then Token:=_TRUE else Token:=_FALSE;
    if Value.cell_type=tNull then Token:=_TRUE;
end;
{------------------------------------------------------------------------}
function IsStr(var Token:Cell):boolean;
var Value:Cell;
begin
   if NumArgs(Token.cdr^)<> 1 then begin
      Error(5);IsStr:=false;exit;
   end;

     Value:=Token.cdr^.car^;
         if Eval(Value)= false then
    begin
         IsStr:=false; exit;
    end;
    {If string return true}
    if Value.cell_type=tString then Token:=_TRUE else Token:=_FALSE;
    if Value.cell_type=tNull then Token:=_TRUE;
end;
{------------------------------------------------------------------------}
function IsSym(var Token:Cell):boolean;
var Value:Cell;
begin
   if NumArgs(Token.cdr^) <> 1 then begin
      Error(5);IsSym:=false;exit;
   end;

     Value:=Token.cdr^.car^;
    if Eval(Value)= false then
    begin
         IsSym:=false; exit;
    end;
    {If symbol return true}
    if Value.cell_type=tSym then Token:=_TRUE else Token:=_FALSE;
    if Value.cell_type=tNull then Token:=_TRUE;
end;
{------------------------------------------------------------------------}
function IsBool(var Token:Cell):boolean;
var Value:Cell;
begin
   if NumArgs(Token.cdr^) <> 1 then begin
      Error(5);IsBool:=false;exit;
   end;

     Value:=Token.cdr^.car^;
    if Eval(Value)= false then
    begin
         IsBool:=false; exit;
    end;
    {If boolean return true}
    if Value.cell_type=tBool then Token:=_TRUE else Token:=_FALSE;
    if Value.cell_type=tNull then Token:=_TRUE;
end;
{------------------------------------------------------------------------}
function IsCons(var Token:Cell):boolean;
var Value:Cell;
begin
   if NumArgs(Token.cdr^) <> 1 then begin
      Error(5);IsCons:=false;exit;
   end;

     Value:=Token.cdr^.car^;
    if Eval(Value)= false then
    begin
         IsCons:=false; exit;
    end;
    {If cons return true}
    if Value.cell_type=tCons then Token:=_TRUE else Token:=_FALSE;
end;
{------------------------------------------------------------------------}
function Princ(var Token:Cell):boolean;
var Args:Cell;
begin
     Args:=Token.cdr^;
     while Args.Cell_Type<>tNull do
     begin
      Token:=Args.car^;

      if Eval(Token) = false then
      begin
            Princ:=false;exit;
      end;
      PrintAtom(Token);
      OutString(' ');
      Args:=Args.cdr^;
     end;
      CreateSym(Token,'',tSym);
end;
{------------------------------------------------------------------------}
function Trace(var Token:Cell):boolean;
var Args:Cell;
begin
     Args:=Token.cdr^;

   if NumArgs(Token.cdr^) <> 1 then begin
      Error(5);Trace:=false;exit;
   end;

     Tracing:=true;
     Token:=Args.car^;
     if Eval(Token)= false then
     begin
          Trace:=false;exit;
     end;
     Tracing:=false;
     outstring(#13);
     outstring('...OK');
     outstring(#13);
end;

{------------------------------------------------------------------------}
function Search(var Token:Cell):boolean;
var Args:Cell;
    found:boolean;
    Goal:Cell;

procedure TreeSearch(var Current:Cell;Goal:Cell);
begin
     if eqCell(Current,Goal) then found:=true
          else begin
               if Current.Car<>nil then TreeSearch(Current.Car^,Goal);
               if Current.Cdr<>nil then TreeSearch(Current.Cdr^,Goal);
               end;
end;

begin
     found:=false;
     Args:=Token.cdr^;

   if NumArgs(Token.cdr^) <> 2 then begin
      Error(5);Search:=false;exit;
   end;

   Token:=Args.car^;
   Goal:=Args.cdr^.car^;

   if ((Eval(Token)=false) or (Eval(Goal)= false)) then
   begin
        Search:=false;exit;
   end;

   TreeSearch(Token,Goal);
   if Found=true then Token:=_TRUE else Token:=_FALSE;
end;
{------------------------------------------------------------------------}
end.
