unit MiscFunc;

interface

uses Declars;
                                           {Returns true if character is...}
 function IsDigit(character: char):boolean;  {a digit}
 function IsAlpha(character: char):boolean;  {an alphabetic character}
 function IsOp(character:char):boolean;      {an operator/ symbol}
 function IsIdChar(character : char) :boolean;{any one of the above}
 function IsAtom(Token:cell):boolean;         {a string/bool/number}

  {Finds the index of a predefined function}
 function FindFuncIndex(FuncName : string): integer;

 {Counts the number of nodes in a list}
 function NumArgs(Token:cell):integer;

 {Recursive power}

 function Power(Num :integer; Exp : integer):longint;

 {Returns true if a cell is equal}
 function eqCell(Cell1:Cell; Cell2:Cell):boolean;

 {Returns true if a list is equal}
 function EqLists(List1:Cell; List2:Cell):boolean;

implementation
{------------------0----------------------------0------------------------}

function IsDigit(character:char):boolean;
 begin
        IsDigit:= ((character>='0') and (character<='9') or (character='.'));
 end;
{------------------0----------------------------0------------------------}
function IsAlpha(character:char):boolean;
 begin
       IsAlpha := ((character>='A') and (character<='z'));
 end;
{------------------0----------------------------0------------------------}
function IsOp(character:char):boolean;
 begin
      IsOp:= (
               (character = '!') or
               (character = '^') or
               (character = '@') or
               (character = '$') or
               (character = '&') or
               (character = '+') or
               (character = '-') or
               (character = '*') or
               (character = '%') or
               (character = '/') or
               (character = '>') or
               (character = '<') or
               (character = '=') or
               (character = #39) or
               (character = '~'));
 end;
{------------------0----------------------------0------------------------}
function IsIdChar(character : char) :boolean;
 begin
      IsIdChar:= (IsAlpha(character) or (isOp(Character)) or (isDigit(character) or
         (character = '_')))
 end;
{------------------0----------------------------0------------------------}
function FindFuncIndex(FuncName : string): integer;
var i :integer;
    found :boolean;
begin
     i:=1;
     found := false;
     {Search for Func name in list}
    while ((i<=NUM_DEFINED) and (found = false)) do
    begin
         if FuncName=Predefined[i] then found:=true
         else inc(i);
    end;
    if found= true then FindFuncIndex := i
    else FindFuncIndex := 0;
end;
{------------------0----------------------------0------------------------}
function IsAtom(Token:cell):boolean;
begin
     IsAtom:= ((Token.cell_type = tNum) or
               (Token.cell_type = tString) or
               (Token.Cell_Type = tBool));
end;
{------------------0----------------------------0------------------------}
function NumArgs(Token:cell):integer;
var Cnt:integer;
begin
    Cnt:=0;
    {Count formal params}
    if Token.Cell_Type=tSym then NumArgs:=1
    else begin
    while (Token.Cell_Type <> tNull) do
        begin
          Token:=Token.cdr^;  inc(Cnt);
     end;
     NumArgs:=Cnt;
    end;
end;
{------------------------------------------------------------------------}
 function Power(Num :integer; Exp : integer):longint;
  begin
  {Normal recursive power algo}
   if Exp = 0 then Power :=1
   else
      Power := Num * Power(Num,Exp-1);
   end;
{------------------------------------------------------------------------}
function eqCell(Cell1:Cell; Cell2:Cell):boolean;
begin
{Test cell for equality}
     EqCell:= false;
       if Cell1.Cell_Type = Cell2.Cell_Type then {If types match}
        begin
            case Cell1.Cell_Type of
            tBool:   if Cell1.Value_Bool = Cell2.Value_Bool then EqCell:=true;
            tNum :   if Cell1.Value_Num = Cell2.Value_Num then EqCell:=true;
            tString: if Cell1.Value_Str = Cell2.Value_Str then EqCell:=true;
            tSym :   if Cell1.Name = Cell2.Name then EqCell:=true;
            tFunc:   if Cell1.Name = Cell2.Name then EqCell:=true;
            tPredefined: if Cell1.Name = Cell2.Name then EqCell:=true;
            {In case of cons, mutually recurse to the eqlists proceudre}
            tCons : if EqLists(Cell1,Cell2) then EqCell:=true;
            end;
       end;
end;
{------------------------------------------------------------------------}
function EqLists(List1:Cell; List2:Cell):boolean;
var  i,Size :integer;
begin
      if NumArgs(List1) <> NumArgs(List2) then {Compare length}
          EqLists:= false
     else
     begin
          size:= NumArgs(List1);
          for i:= 1 to Size do   {check each node of the list}
          begin
               if eqCell(List1.Car^, List2.Car^) = false then
               begin
                    EqLists:=false; exit;
               end;

               List1:=List1.cdr^;  {Next node}
               List2:=List2.cdr^;   {Next node}
          end;
     EqLists:=true;
     end;
end;
{------------------------------------------------------------------------}
end.